{
    ACM ICPC 2003-2004 NEERC

    Problem:    Entropy
    Author:     Vladimir Pinaev
    Solution:   Andrew Stankevich
}

{$APPTYPE CONSOLE}
{$O-,R+,Q+}
{$DEFINE ALLOWMULTITEST}

program entropy;

uses
    sysutils;

label
    success;

const
    chars: string = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789. ';

    eps = 0.005;

    max = 1000;

var
    ent: extended;
    s: string;
    t, i, j, k, l, m, n: longint;
    p, q, dnt: extended;

begin
    readln(s);
    {$IFNDEF ALLOWMULTITEST}
    if not eof then runerror(239);
    {$ENDIF}
    if length(s) <> 4 then runerror(239);
    if not (s[1] in ['0'..'6']) then runerror(239);
    if s[2] <> '.' then runerror(239);
    if not (s[3] in ['0'..'9']) then runerror(239);
    if not (s[4] in ['0'..'9']) then runerror(239);
    if (s[1] = '6') and (s <> '6.00') then runerror(239);

    decimalseparator := '.';
    ent := strtofloat(s);

    t := trunc(ent);

    for i := (1 shl t) - 1 to 63 do
    begin
        if i > 0 then 
            n := max div i 
        else
            n := 0;
        for j := 0 to n do
        begin
            for k := 1 to max - i * j do
            begin
                p := j / (i * j + k);
                q := k / (i * j + k);
                dnt := q * ln(q) / ln(2);
                if j > 0 then
                    dnt := dnt + i * p * ln(p) / ln(2);
                if abs(dnt + ent) < eps then
                begin
                    for l := 1 to i do
                        for m := 1 to j do
                            write(chars[l]);
                    for m := 1 to k do
                        write(chars[i + 1]);
                    writeln;
                    goto success;
                end;
            end;
        end;
    end;

    runerror(240);

    success:

    close(input);
    close(output);
end.